# SPDX-License-Identifier: CC0-1.0

{ nixpkgs, dhallApps, packages }:

nixpkgs.writeScriptBin "render-init" (with nixpkgs.buildPackages; ''
  #!${runtimeShell}
  set -eu
  export DHALL_PRELUDE=''${DHALL_PRELUDE:-${packages.dhallPrelude}/package.dhall}
  export DHALL_GENODE=''${DHALL_GENODE:-${packages.dhallGenode}/package.dhall}
  ${dhallApps.dhall.program} text \
    <<< "(env:DHALL_GENODE).Init.render ($(cat))" \
    | ${nixpkgs.buildPackages.libxml2}/bin/xmllint \
        -format \
        -schema ${packages.genode-sources}/repos/os/src/init/config.xsd \
        - \
    | sed 's/&gt;/>/g'
'')
