# SPDX-License-Identifier: CC0-1.0

{ stdenv, fetchgit, dhallApps, prelude }:

stdenv.mkDerivation {
  name = "dhall-genode";
  src = fetchgit {
    url = "https://git.sr.ht/~ehmry/dhall-genode";
    rev = "16cad9fbbee3fbd1c167377c93ee1d60f9d21e37";
    sha256 = "0gjad37zd1kb5dlnkb3m8pd1ibzcc9yqf6vgyv3imffj1vhdl14n";
  };
  DHALL_PRELUDE = prelude + "/package.dhall";
  buildCommand = ''
    export XDG_CACHE_HOME=$TMPDIR
    cp -r $src $out
    chmod +w -R $out
    echo $DHALL_PRELUDE > $out/Prelude.dhall
    find $out -type f -exec \
      ${dhallApps.dhall.program} freeze --all --inplace {} \;
  '';
}
