-- SPDX-License-Identifier: CC0-1.0

let Genode = env:DHALL_GENODE

let Init = Genode.Init

let Child = Init.Child

let wrapSotest
    : Init.Type → Child.Type
    =   λ(init : Init.Type)
      → Child.nested
          (toMap { init = Genode.Init.toChild init Init.Attributes.default })
          Child.Attributes::{
          , binary = "sotest-harness"
          , resources = Init.Resources::{ ram = Genode.units.MiB 4 }
          , routes =
              [ Init.ServiceRoute.parentLabel
                  "LOG"
                  (Some "SOTEST")
                  (Some "unlabeled")
              , Init.ServiceRoute.parent "IO_MEM"
              , Init.ServiceRoute.parent "IO_PORT"
              , Init.ServiceRoute.parent "IRQ"
              , Init.ServiceRoute.child "Timer" "timer"
              ]
          }

in  wrapSotest
